#include <bits/stdc++.h>
using namespace std;

int calc(int l, int r, vector<int> p){
    int k = 0, i = 0;
    int n = p.size();
    l--;
    r--;
    while (p[i] <= l) i++;
    k += i;
    i = n-1;
    while (p[i] > r) {
        i--;
        k++;
    }
    return n-k;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n, l, r;
    string s;
    vector<int> p, ans; //протиріччя, відповідь
	cin >> s >> n;
    
    for (int i = 1; i < s.size();i++){
        if (s[i] < s[i-1]) p.push_back(i);
    }
    for (int i = 0; i < n; i++){
        cin >> l >> r;
        cout << calc(l,r,p)+1 << endl;
    }
    
}
